/**************************************************************************
*                                                                                         
*  cfnvram.h - 2.6 Block driver for using the Internal NVRAM of  the SoM-5282EM            
*  closely based on Rubini's sbull driver                                                 
*                                                                                         
*  (C) Copyright 2005, EMAC.Inc www.emacinc.com                                           
*      written by              NZG ngustavson@emacinc.com                                 
*                                                                                         
**************************************************************************/
#include <linux/ioctl.h>

/*
 * Macros to help debugging
 */

#undef PDEBUG             /* undef it, just in case */
#ifdef CFNV_DEBUG
#  ifdef __KERNEL__
     /* This one if debugging is on, and kernel space */
#    define PDEBUG(fmt, args...) printk( KERN_DEBUG "cfnvram: " fmt, ## args)
#  else
     /* This one for user space */
#    define PDEBUG(fmt, args...) fprintf(stderr, fmt, ## args)
#  endif
#else
#  define PDEBUG(fmt, args...) /* not debugging: nothing */
#endif

#undef PDEBUGG
#define PDEBUGG(fmt, args...) /* nothing: it's a placeholder */


#define CFNV_MAJOR 100        
#define CFNV_DEVS 1        /* one disk */
#define CFNV_RAHEAD 2      /* two sectors */
#define CFNV_SIZE 63     /* 63 K */
#define CFNV_BLKSIZE 1024  /* 1k blocks (unused)*/
#define CFNV_HARDSECT 512  /* 2.2 and 2.4 can used different values */
#define CFNV_NSEC 126  /* 2.2 and 2.4 can used different values */

#define CFNVR_MAJOR 0      /* Dynamic major for raw device */
