/***************************************************************************
                          mcfqadc.c  -  Coldfire Internal AtoD device function calls
                          Some code taken from Alan Carvalho de Assis's GPL qadc driver
    					  (C) Copyright 2005, EMAC.Inc www.emacinc.com   
                             -------------------
    begin                : Thur Dec 22 2005
    email                : ngustavson@emacinc.com

 ***************************************************************************/

/***************************************************************************
 *                                                                         
 *   This program is free software; you can redistribute it and/or modify  
 *   it under the terms of the GNU General Public License as published by  
 *   the Free Software Foundation; either version 2 of the License, or     
 *   (at your option) any later version.                                   
 *                                                                         
 ***************************************************************************/
 #include <linux/slab.h>
#include <asm/mcfqadc.h>
 
qadc_dev *QADC_Device(void){
	int counter;
	qadc_dev *qadc;
	
	
	if ((qadc = kmalloc(sizeof(qadc_dev), GFP_KERNEL)) == NULL) {//create qadc device  
                return(NULL);
        }
	
	QADCMCR = 0x40; //QADC operates normally -why not zero? NZG
	QACR0 = 0x7f; //QCLK, disable extern mux, set the trigger assigments
	//QACR1 = 0x1100; //disable interrupts, select operate mode
	QACR1 = 0; //disable interrupts, select operate mode
	QACR2= 0x11; //disable queue 2
	QASR0 = 0;

	//for(counter=0; counter<64; counter++){
	for(counter=0; counter<sizeof(qadc_channel); counter++){
		CCW[counter] = qadc_channel[counter];
		RJURR[counter] = 0;
	}
         
return qadc;
}

qadc_dev *QADC_Destroy_Device(qadc_dev *dev){
	kfree(dev);
	return NULL;
}

u16 *QADC_Read_All(qadc_dev *device){
	int counter=0, address_counter;

	//QACR1 = 0x1100; //Active software triggered continuos-scan mode

	QACR1 = 0x0100; //software triggered single-scan mode

	QACR1 |= 0x2000; //Trigger Scan

	QADCCDEBUG("Executing qadc_read\n");

	while(counter<NUMCHANNELS){ //read only 8 first channel
		/**if(status == (NUMCHANNELS-1) ){ //When the queue is full, read it to RAM**/			
		if(QUEUE_COMPLETED){
			QACR1=0; //Deactive scan mode
			QADCCDEBUG("Data in queue, Scan deactivated\n");
			for(address_counter=0; address_counter<NUMCHANNELS; address_counter++){
				device->buffer[counter] = RJURR[address_counter]; //Read a value off the queue
				QADCCDEBUG("RJURR %u = %x\n",counter,device->buffer[counter]);				
				counter++;
			}
		}
	}

	QACR1 = 0;
	QASR0 = 0;
	return &device->buffer[0];
}
 