/***************************************************************************
                          DS1722.h  -
					DS1722 temperature sensor defines
                             -------------------
    begin                : Tue May 15 2006
    email                : support@emacinc.com
 ***************************************************************************/
#ifndef DS1305RTC_H
#define DS1305RTC_H
#include <asm/coldfire.h> 
#include <asm/mcf_qspi.h>            

typedef struct ds1722_qspi_device{
	qspi_dev *qspi;
	int cs;	
}ds1722_qspi_device;

#define DSNAME 		"ds1722"
#define DS_DRIVER_V "1.0"

#define CONTROLW									0x80
	#define EIGHTBIT									0
	#define NINEBIT									2
	#define CONTINOUS_CONVERSION	0

#define CONTROLR		0
#define DATAL				1
#define DATAH				2

/**
 * The ds1722 requires not only that the chip select be asserted, but 
 * that it was previously de-asserted prior to access.
 * this routine quickly dips the chip select prior to access.
 * Note that in a multiplexed system, this will result in another device being accessed 
 * (although no data will be passed to it) for this reason it's abstracted here, as it may need to be 
 * board specific.
 */
static inline void CSDIP(int cs){
	int buff=PQSPAR;
 	PORTQS= ((~cs)>>5)&BOARDCSMASK;
 	PQSPAR=0x07;
 	//printk("portqs = %x\n",PORTQS);
  	//printk("pqspars = %x\n",PQSPAR);
 	udelay(1);
	PQSPAR=buff;
	//printk("pqspars = %x\n",PQSPAR);
 	udelay(1);
}

#endif /*DS1722_H*/