/***************************************************************************
                          ltc1290.h  -  SPI AtoD device function calls
                          Depends on the stackable qspi driver
    					  (C) Copyright 2005, EMAC.Inc www.emacinc.com   
                          Modified up from the pcm-37e12 version
                             -------------------
    begin                : Thur July 28 2005
    email                : ngustavson@emacinc.com

 ***************************************************************************/

/***************************************************************************
 *                                                                         
 *   This program is free software; you can redistribute it and/or modify  
 *   it under the terms of the GNU General Public License as published by  
 *   the Free Software Foundation; either version 2 of the License, or     
 *   (at your option) any later version.                                   
 *                                                                         
 ***************************************************************************/
#ifndef _LTC1290_H_
#define _LTC1290_H_

#define NUMCHANNELS 8
#define MSBF	0x04
#define UNIP	0x08
#define BIT8	0	
#define POFF	1
#define BIT12	2
#define BIT16	3
#define READCMD  (MSBF|BIT16|UNIP)

#ifdef __KERNEL__
#include <asm/mcf_qspi.h>
#include <linux/types.h>
#include <asm/types.h>

typedef struct ltc_dev {
	qspi_dev *spi;
	int qcr_cs; 
	u16 buffer[NUMCHANNELS+1];
}ltc_dev;

ltc_dev *LTC_SPIDevice(int qcr_cs);
u16 *LTC1290_Read_All(ltc_dev *device);
u16 LTC1290_Read_Chan(ltc_dev *device,int channel);
ltc_dev *LTC_Destroy_Device(ltc_dev *dev);

#ifdef CONFIG_SOM100ES

#define SOM100_LTC_CS 0

static inline ltc_dev *LTC1290_board_init(void){
 return LTC_SPIDevice(SOM100_LTC_CS);
}

#endif //CONFIG_SOM100ES

#endif //__KERNEL__


#ifdef CHARACTER_INTERFACE
#define DRIVERCODE 'L'
#define READALL							_IOR(DRIVERCODE,0,__u16)
#define GETCHANNELNUM			_IOR(DRIVERCODE,1,__u16)
#endif //CHARACTER_INTERFACE

#endif //_LTC1290_H_
