#ifndef MCFDMATIMER_H_
#define MCFDMATIMER_H_

#include <asm/coldfire.h>

#define MCFDMATIMER_BASE0 0x400
#define MCFDMATIMER_BASE1 0x440
#define MCFDMATIMER_BASE2 0x480
#define MCFDMATIMER_BASE3 0x4C0

#define MCFDMATIMER_TMR		0x00
	#define MCFDMATIMER_TMR_CLK1		0x02
	#define MCFDMATIMER_TMR_RESTART	0x08
	#define MCFDMATIMER_TMR_DISORI		0
	#define MCFDMATIMER_TMR_ENABLE	0x01

#define MCFDMATIMER_TXMR	0x02
#define MCFDMATIMER_TER		0x03
#define MCFDMATIMER_TRR		0x04
#define MCFDMATIMER_TCR		0x08
#define MCFDMATIMER_TCN		0x0C

#define DTMR0 	*(volatile u16 *) (MCF_IPSBAR + MCFDMATIMER_BASE0+MCFDMATIMER_TMR)
#define DTXMR0 	*(volatile u8 *) (MCF_IPSBAR + MCFDMATIMER_BASE0+MCFDMATIMER_TXMR)
#define DTER0 		*(volatile u8 *) (MCF_IPSBAR + MCFDMATIMER_BASE0+MCFDMATIMER_TER)
#define DTRR0 		*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE0+MCFDMATIMER_TRR)
#define DTCR0 		*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE0+MCFDMATIMER_TCR)
#define DTCN0 	*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE0+MCFDMATIMER_TCN)

#define DTMR1 	*(volatile u16 *) (MCF_IPSBAR + MCFDMATIMER_BASE1+MCFDMATIMER_TMR)
#define DTXMR1 	*(volatile u8 *) (MCF_IPSBAR + MCFDMATIMER_BASE1+MCFDMATIMER_TXMR)
#define DTER1 		*(volatile u8 *) (MCF_IPSBAR + MCFDMATIMER_BASE1+MCFDMATIMER_TER)
#define DTRR1 		*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE1+MCFDMATIMER_TRR)
#define DTCR1 		*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE1+MCFDMATIMER_TCR)
#define DTCN1 	*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE1+MCFDMATIMER_TCN)

#define DTMR2 	*(volatile u16 *) (MCF_IPSBAR + MCFDMATIMER_BASE2+MCFDMATIMER_TMR)
#define DTXMR2 	*(volatile u8 *) (MCF_IPSBAR + MCFDMATIMER_BASE2+MCFDMATIMER_TXMR)
#define DTER2 		*(volatile u8 *) (MCF_IPSBAR + MCFDMATIMER_BASE2+MCFDMATIMER_TER)
#define DTRR2 		*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE2+MCFDMATIMER_TRR)
#define DTCR2 		*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE2+MCFDMATIMER_TCR)
#define DTCN2 	*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE2+MCFDMATIMER_TCN)

#define DTMR3 	*(volatile u16 *) (MCF_IPSBAR + MCFDMATIMER_BASE3+MCFDMATIMER_TMR)
#define DTXMR3 	*(volatile u8 *) (MCF_IPSBAR + MCFDMATIMER_BASE3+MCFDMATIMER_TXMR)
#define DTER3 		*(volatile u8 *) (MCF_IPSBAR + MCFDMATIMER_BASE3+MCFDMATIMER_TER)
#define DTRR3 		*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE3+MCFDMATIMER_TRR)
#define DTCR3 		*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE3+MCFDMATIMER_TCR)
#define DTCN3 	*(volatile u32 *) (MCF_IPSBAR + MCFDMATIMER_BASE3+MCFDMATIMER_TCN)

#endif /*MCFDMATIMER_H_*/
