/***************************************************************************
                          ltc1290.h  -  SPI AtoD device function calls
                          Depends on the stackable qspi driver
    					  (C) Copyright 2005, EMAC.Inc www.emacinc.com   
                          Modified up from the pcm-37e12 version
                             -------------------
    begin                : Thur Dec 22 2005
    email                : ngustavson@emacinc.com

 ***************************************************************************/

/***************************************************************************
 *                                                                         
 *   This program is free software; you can redistribute it and/or modify  
 *   it under the terms of the GNU General Public License as published by  
 *   the Free Software Foundation; either version 2 of the License, or     
 *   (at your option) any later version.                                   
 *                                                                         
 ***************************************************************************/
#ifndef _MCFQADC_H_
#define _MCFQADC_H_

#define NUMCHANNELS 8


#define ENDQUEUE 63

#ifdef __KERNEL__
#include <asm/types.h>
#include <asm/coldfire.h>              
#include <linux/delay.h>

typedef struct qadc_dev{
		u16 buffer[NUMCHANNELS];
}qadc_dev;

static const int qadc_channel[] = {0,1,2,3,52,53,55,56,ENDQUEUE};

/*QADC registers*/
#define QADCMR_BASE		0x190000

#define QADCMCR		*(volatile u16 *)(MCF_MBAR + QADCMR_BASE+0)

#define QACR0				*(volatile u16 *)(MCF_MBAR + QADCMR_BASE+0xa)
#define QACR1				*(volatile u16 *)(MCF_MBAR + QADCMR_BASE+0xc)
#define QACR2				*(volatile u16 *)(MCF_MBAR + QADCMR_BASE+0xe)

#define QASR0				*(volatile u16 *)(MCF_MBAR + QADCMR_BASE+0x10)
	#define 	CF1				0x8000

#define QASR1				*(volatile u16 *)(MCF_MBAR + QADCMR_BASE+0x12)

#define CCW					((volatile u16 *)(MCF_MBAR + QADCMR_BASE+0x200))
#define RJURR				((volatile u16 *)(MCF_MBAR + QADCMR_BASE+0x280))

#define QUEUE_COMPLETED (QASR0&CF1)


qadc_dev *QADC_Device(void);
u16 *QADC_Read_All(qadc_dev *device);
qadc_dev *QADC_Destroy_Device(qadc_dev *dev);

//#define QADCC_DEBUG

#undef QADCCDEBUG
#ifdef QADCC_DEBUG
#define QADCCDEBUG(fmt, args...) printk(fmt"\n", ## args)
#else 
#define QADCCDEBUG(fmt, args...) 
#endif
#endif


#ifdef CHARACTER_INTERFACE
#define DRIVERCODE 'L'
#define READALL							_IOR(DRIVERCODE,0,__u16)
#define GETCHANNELNUM			_IOR(DRIVERCODE,1,__u16)
#endif //CHARACTER_INTERFACE

#endif //_MCFQADC_H_
