/***************************************************************************
                          tlv5614.h  -  SPI DtoA device function calls
                           Depends on the stackable qspi driver
    					  (C) Copyright 2005, EMAC.Inc www.emacinc.com  
                          Modified up from the pcm-37e12 version
                             -------------------
    begin                : Fri July 29 2005
    email                : ngustavson@emacinc.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _TLV5614_H_
#define _TLV5614_H_

# define NUMCHANNELS 4

#ifdef __KERNEL__
#include <linux/types.h>
#include <asm/types.h>
#include <asm/mcf_qspi.h>
#include <asm/coldfire.h>  

typedef struct tlv_dev{
	int qcr_cs;
	u8 csholder;
	qspi_dev *spi;
	u16 shadow[NUMCHANNELS];
}tlv_dev;

/**
 * prototypes
 */
 
tlv_dev *TLV_SPIDevice(int qcr_cs);
tlv_dev *TLV_Destroy_Device(tlv_dev *dev);
void TLV5614_Write(tlv_dev *dev,int channel, u16 value);
void TLV5614_Hardware_Init(tlv_dev *dev);

#ifdef CONFIG_SOM100ES
/**
 *  for the SoM-100ES toggling LDAC means toggling PE3
 */
#define MCF5282_GPIO_PORTE 0x100004
#define MCF5282_GPIO_PEPAR 0x100052
#define MCF5282_GPIO_DDRE 0x100018
#define MCF5282_GPIO_SETE 0x10002C
#define MCF5282_GPIO_CLRE 0x100040
#define MCF5282_GPIO_CCR 0x110004
 
#define PEPAR *((volatile u16 *) (MCF_IPSBAR + MCF5282_GPIO_PEPAR))
#define DDRE *((volatile u8 *) (MCF_IPSBAR + MCF5282_GPIO_DDRE))
#define SETE *((volatile u8 *) (MCF_IPSBAR + MCF5282_GPIO_SETE))
#define CLRE *((volatile u8 *) (MCF_IPSBAR + MCF5282_GPIO_CLRE))
#define CCR *((volatile u16 *) (MCF_IPSBAR + MCF5282_GPIO_CCR))
#define PORTE *((volatile u8 *) (MCF_IPSBAR + MCF5282_GPIO_PORTE))
 
#define SOM100_LDAC_MASK 0x08
#define SOM100_TLV_CS	1
#define PEPAR_MASK 0x40
//#define PEPAR_MASK 0xff
#define SZEN 0x40

static inline void TLV_INIT_LINES(void){
	CCR&=~SZEN;
	PEPAR&=~(PEPAR_MASK);
	DDRE|=SOM100_LDAC_MASK;
}

static inline void DACS_ON(tlv_dev *dev){
	qspi_mutex_down();
	CSSTEAL(SOM100_TLV_CS,&dev->csholder);
}

static inline void DACS_OFF(tlv_dev *dev){
	CSRETURN(dev->spi,&dev->csholder);
	qspi_mutex_up();
}

static inline void LDAC_ON(tlv_dev *dev){
	CLRE =  ~SOM100_LDAC_MASK;
}

static inline void LDAC_OFF(tlv_dev *dev){
	SETE =  SOM100_LDAC_MASK;
}

static inline tlv_dev *TLV5614_board_init(void){
TLV_INIT_LINES();
 return TLV_SPIDevice(SOM100_TLV_CS);
}

#endif //CONFIG_SOM100ES
#endif //__KERNEL__

#ifdef CHARACTER_INTERFACE
#define DRIVERCODE 'L'
#define WRITEALL						_IOW(DRIVERCODE,0,__u16)
#define READALL							_IOR(DRIVERCODE,0,__u16)
#define GETCHANNELNUM			_IOR(DRIVERCODE,1,__u16)
#endif //CHARACTER_INTERFACE

#endif //_TLV5614_H_
